/*
	mode-median-test-case.js
	Tests for mode and median.
*/

//=========================================================

//Housekeeping - add name of test class
//Note: param must be a string
addTestCase("StatsModeMedianTestCase");

//=========================================================

class StatsModeMedianTestCase extends TestCase {
	//ivars: unit
	
	getUnitName() {
		/*xdlm	
		Housekeeping - return class name of unit*/
		//Housekeeping - return class name of unit
		return 'Stats';
	}	
	
	//-----------------
	//Setup

	beforeEach() {
		//Called before each test for test setup (if needed)
		super.beforeEach();
		/*Construct a unit model for testing*/
		this.unit = new Stats(this.array1());
	}	
	
	array1() {
		//Called before each test for test setup (if needed)
		super.beforeEach();
		/*Construct a unit model for testing*/
		return [40, 10, 30, 20];
	}		
	
	//-----------------
	//Tests
	
	testMode1() {
		this.assertEquals(this.array1().sort(), this.unit.mode().sort());
	}
	
	testMode2() {
		this.unit = new Stats([40, 10, 30, 20, 30]);	
		this.assertEquals([30], this.unit.mode());
	}	
	
	testMode3() {
		this.unit = new Stats([10, 40, 10, 30, 20, 30]);	
		this.assertEquals([10, 30], this.unit.mode().sort());
	}		

	testMedianOddCase() {
		this.unit = new Stats([30, 10, 20]);		
		this.assertEquals(20, this.unit.median());		
	}			
	
	testMedianEvenCase() {
		this.unit = new Stats([30, 10, 40, 20]);		
		this.assertEquals(25, this.unit.median());		
	}	
	
	testMedianOneValue() {
		this.unit = new Stats([200]);		
		this.assertEquals(200, this.unit.median());		
	}		
	
	testMedianEvenCaseFloatingPointCenter() {
		this.unit = new Stats([20, 15, 20, 15]);		
		this.assertEquals(17.5, this.unit.median());		
	}				
	
} 
	
