/*
	StatsTestCase
	Unit test that tests a Stats object.
	Ivar "unit" is the object that is tested.
	See method "beforeEach" for initialization of unit that will be tested
*/

//=========================================================

//Housekeeping - add name of test class
//Note: param must be a string
addTestCase("StatsTestCase");

//=========================================================

class StatsTestCase extends TestCase {
	//ivars: unit
	
	getUnitName() {
		/*xdlm	
		Housekeeping - return class name of unit*/
		//Housekeeping - return class name of unit
		return 'Stats';
	}	
	
	//-----------------
	//Setup

	beforeEach() {
		//Called before each test for test setup (if needed)
		super.beforeEach();
		/*Construct a unit model for testing*/
		this.unit = new Stats(this.array1());
	}	
	
	array1() {
		//Called before each test for test setup (if needed)
		super.beforeEach();
		/*Construct a unit model for testing*/
		return [40, 10, 30, 20];
	}		
	
	//-----------------
	//Tests
	
	testCount() {
		this.assertEquals(4, this.unit.count());
	}
	
	testSum() {
		this.assertEquals(100, this.unit.sum());
	}	
	
	testMin1() {
		this.assertEquals(10, this.unit.min());
	}		
	
	testMin2() {
		this.unit = new Stats([40]);		
		this.assertEquals(40, this.unit.min());
	}		
	
	testMin3() {
		this.unit = new Stats([40, -10]);		
		this.assertEquals(-10, this.unit.min());
	}			
	
	testMax1() {
		this.assertEquals(40, this.unit.max());
	}	
	
	testMax2() {
		this.unit = new Stats([40]);		
		this.assertEquals(40, this.unit.max());
	}		
	
	testMax3() {
		this.unit = new Stats([40, -10]);		
		this.assertEquals(40, this.unit.max());
	}	
	
	testAve() {
		this.assertEquals(25, this.unit.ave());
	}	
	
} 
	
