/*
	counter-controller.js
	Controller is interface and event manager between View and model
*/

function buildController() {
		//one and only controller (global)
		controller = new Controller();
}	

class Controller extends AbstractController {
	
	//----------------------------
	//Virtual - required
		
	newModel() {
		//Override
		return new Stats();
	}
	
	//----------------------------
	//Virtual - optional
		
	getRefreshableFields() {
		//fields that should refresh on a change
		return ['count', 'sum', 'min', 'max', 'ave'];
	}	
	
	getChangeableFields() {
		//fields that can be changed
		return ['nums'];
	}	
	
	//----------------------------	
	
	attachEvents() {
		//Attach field event to event handler
		//ui element name, event name, event handler method name
		super.attachEvents();

		//actions
		this.attach('calc', 'click', 'clickedCalc');				
		
		//this.attachEnterKeyTo('clickedCalc');
	}
	
	//-------------------------------
	//Action event handlers -- actions (e.g. button clicks 'clicked')
	
	clickedCalc() {
		//this.model.setNumsFromString(this.elem('nums').value);	
		//Refresh all the output fields
		this.refresh();
	}
	
}



